// JGameEx16.java

import ch.aplu.jgamegrid.*;
import java.awt.Color;
import java.awt.Point;

public class JGameEx16 extends GameGrid
{
  public JGameEx16()
  {
    super(10, 10, 60, Color.red);
    Ball ball = new Ball();
    Playball playBall = new Playball(ball);
    addActor(ball, new Location(5, 5));
    addActor(playBall, new Location(0, 0));
    show();
  }

  public static void main(String[] args)
  {
    new JGameEx16();
  }
}

class Playball extends Actor
{
  private Ball ball;
  private double vx, vy, x, y;
  private final double speedFactor = 10;

  public Playball(Ball ball)
  {
    super("sprites/playStone_0.png");
    this.ball = ball;
  }

  public void act()
  {
    moveNotInGrid();
    tryToTouch();
  }

  public void moveNotInGrid()
  {
    x = vx * speedFactor + x;
    y = vy * speedFactor + y;
    setPixelLocation(new Point((int)x, (int)y));
  }

  private void tryToTouch()
  {
    if (ball.getLocation().equals(getLocation()))
    {
      ball.setLocation(gameGrid.getRandomEmptyLocation());
      setFollowDirection();
    }
  }

  private void setFollowDirection()
  {
    Point ballPos = ball.getPixelLocation();
    int vx0 = ballPos.x - getPixelLocation().x;
    int vy0 = ballPos.y - getPixelLocation().y;
    double vectorLength = getPixelLocation().distance(ballPos);
    vx = vx0 / vectorLength;
    vy = vy0 / vectorLength;
  }

  public void reset()
  {
    setFollowDirection();
    x = getPixelLocation().x;
    y = getPixelLocation().y;
  }
}

// --------------------- class Ball ---------------------------
class Ball extends Actor
{
  public Ball()
  {
    super(true, "sprites/ball.gif");
  }
}
